## libpappsomspp 0.8.15

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

# CMake script for PAPPSOms++ library
# Authors: Olivier Langella & Filippo Rusconi
# Created: 03/03/2015
# Rework: April 2020 (Coronavirus confinement)

############################################################
############################################################
# Basic information about project

project(libpappsomspp)

set(PAPPSOMSPP_VERSION_MAJOR "0")
set(PAPPSOMSPP_VERSION_MINOR "8")
set(PAPPSOMSPP_VERSION_PATCH "15")
set(PAPPSOMSPP_VERSION "${PAPPSOMSPP_VERSION_MAJOR}.${PAPPSOMSPP_VERSION_MINOR}.${PAPPSOMSPP_VERSION_PATCH}")
# This *NUMERICAL* VERSION is parseable by the makeOrigTarball script.
set(VERSION 0.8.15)

# Command to enable debug and tests
# cmake -DCMAKE_BUILD_TYPE=Debug  -DMAKE_TESTS=1 -DUSEPAPPSOTREE=0 ..

# This line MUST be located prior to include'ing GNUInstallDirs !!!
# Note that the CMAKE_LIBRARY_ARCHITECTURE is only accounted for
# CMAKE_INSTALL_PREFIX = /usr (not /usr/local, for example).
set(CMAKE_INSTALL_PREFIX /usr)

message(STATUS "${BoldYellow}CMAKE_LIBRARY_ARCHITECTURE: ${CMAKE_LIBRARY_ARCHITECTURE}${ColourReset}")

include(GNUInstallDirs)

message(STATUS "Set CMAKE_INSTALL_PREFIX to ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Install directory prefix: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "CMAKE_INSTALL_FULL_LIBDIR: ${CMAKE_INSTALL_FULL_LIBDIR}")
message(STATUS "CMAKE_INSTALL_FULL_INCLUDEDIR: ${CMAKE_INSTALL_FULL_INCLUDEDIR}")

# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)
#message("CMAKE_MODULE_PATH:" ${CMAKE_MODULE_PATH})


# This include must come before all the others
# It must include the config-generated config.h file
# before the others.
#include_directories(${CMAKE_BINARY_DIR})

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN64 if SYSTEM_UNAME_S is "^.*MING64.*"
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldRed}Configuring build for project ${PROJECT_NAME}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json" )
  execute_process( COMMAND cmake -E copy_if_different
    ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
    ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
    )
endif()


# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)
# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall.${ColourReset}")
add_definitions(-Wall)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
  message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
  add_definitions(-Werror)
endif()

message(STATUS "${BoldRed}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")


#############################################################
#############################################################
# Platform-specific CMake configuration
if(MXE)
  # Run the following cmake command line:
  # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../development
  include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
  #include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-olivier.cmake)

  # Set the name to the systemUname variable because in this situation that name
  # is not found, it it passed as a flag in the command line.
  set(SYSTEM_UNAME_S "mxe")

elseif(UNIX AND NOT APPLE)
  # Run the following cmake command line:
  # cmake -DBUILD_USER_MANUAL=1 -DCMAKE_BUILD_TYPE=Debug

  include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)

elseif(WIN32 OR _WIN32)

  if(WIN10MINGW64)
    include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
  endif()

elseif(APPLE)
  # Run the following cmake command line:
  # cmake -DBUILD_USER_MANUAL=0 -DCMAKE_BUILD_TYPE=Release ../development

  include(${CMAKE_TOOLCHAINS_PATH}/apple-macport-toolchain.cmake)
endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${PROJECT}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")


#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

# Gee, do not set that to default!
# set(MAKE_TESTS 1)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
    FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
  message(STATUS "Compiling in release mode.")
  add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
  message(STATUS "Compiling in debug mode with MAKE_TESTS: ${MAKE_TESTS}.")
  message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
  add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
  message(STATUS "Compiling in release with debug info mode.")
endif( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")


# PWIZLITE
if(NOT PwizLite_FOUND)
  message(STATUS "PwizLite not yet found. Searching for it.")
  find_package(PwizLite REQUIRED) 
endif()
message(STATUS "PwizLite_INCLUDE_DIRS: ${PwizLite_INCLUDE_DIRS}")
message(STATUS "PwizLite_LIBRARIES: ${PwizLite_LIBRARIES}")


# BOOST
if(NOT Boost_FOUND)
  message(STATUS "Boost not yet found. Searching for it.")
  find_package(Boost COMPONENTS iostreams thread filesystem chrono REQUIRED) 
endif()
message(STATUS "Boost_LIBRARIES found ${Boost_LIB_VERSION}")
message(STATUS "Boost_INCLUDES: ${Boost_INCLUDE_DIRS}")
message(STATUS "Boost_LIB_DIRS: ${Boost_LIBRARY_DIRS}")


if(QCustomPlot_FOUND)
else (QCustomPlot_FOUND)
  set(QCustomPlot_DIR ${CMAKE_MODULE_PATH})
  find_package(QCustomPlot REQUIRED)
endif(QCustomPlot_FOUND)


if(Alglib_FOUND)
else (Alglib_FOUND)
  set(Alglib_DIR ${CMAKE_MODULE_PATH})
  find_package(Alglib REQUIRED)
endif(Alglib_FOUND)


if(Zstd_FOUND)
else (Zstd_FOUND)
  set(Zstd_DIR ${CMAKE_MODULE_PATH})
  find_package(Zstd REQUIRED)
endif(Zstd_FOUND)


if(SQLite3_FOUND)
else(SQLite3_FOUND)
  set(SQLite3_DIR ${CMAKE_MODULE_PATH})
  find_package(SQLite3 REQUIRED)
endif(SQLite3_FOUND)


if(NOT USEPAPPSOTREE)
  set(USEPAPPSOTREE 0)
endif(NOT USEPAPPSOTREE)

if(NOT USEQT4)
  if(NOT USEQT5)
    set(USEQT5 1)
  endif(NOT USEQT5)
endif(NOT USEQT4)

if(USEQT5)
  if(NOT PAPPSOMSPPWIDGET)
    set(PAPPSOMSPPWIDGET 1)
  endif(NOT PAPPSOMSPPWIDGET)
endif(USEQT5)


# Set the CMAKE_PREFIX_PATH for the find_library fonction when using non
# standard install location
if(CMAKE_INSTALL_PREFIX)
  set(CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}" ${CMAKE_PREFIX_PATH})
endif(CMAKE_INSTALL_PREFIX)

# Subdirectories
message(STATUS "Adding subdirectory src for PROJECT: ${PROJECT}")
add_subdirectory(doc)

message(STATUS "Adding subdirectory doc for PROJECT: ${PROJECT}")
add_subdirectory(src)

# Doxygen
if(UNIX AND NOT APPLE)
  find_package(Doxygen)

  if(DOXYGEN_FOUND)

    add_custom_target (apidoc cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-build
      COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-build
      COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-build
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

    add_custom_target(apidoc-stable cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-stable
      COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
      COMMAND echo "HTML_HEADER=header.html" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
      COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-stable
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

  endif(DOXYGEN_FOUND)

endif(UNIX AND NOT APPLE)

# Packager
set(CPACK_PACKAGE_NAME "libpappsomspp")
set(CPACK_PACKAGE_VENDOR "PAPPSO Development Team")
set(CPACK_PACKAGE_VERSION "${PAPPSOMSPP_VERSION}")
set(CPACK_PACKAGE_VERSION_MAJOR "${PAPPSOMSPP_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${PAPPSOMSPP_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${PAPPSOMSPP_VERSION_PATCH}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The PAPPSO C++ library for mass spectrometry")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
set(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS")
set(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_IGNORE_FILES
  "CMakeFiles"
  "Makefile"
  "_CPack_Packages"
  "CMakeCache.txt"
  ".*\\\\.git"
  ".*\\\\.gz"
  ".*\\\\.deb"
  ".*\\\\.rpm"
  ".*\\\\.dmg"
  ".*\\\\..*\\\\.swp"
  "src/\\\\..*"
  "src/libbpp*"
  "debian/tmp"
  "debian/libbpp.*/"
  "debian/libbpp.*\\\\.so.*"
  "debian/libbpp.*\\\\.a"
  "debian/libbpp.*\\\\.substvars"
  "debian/libbpp.*\\\\.debhelper"
  "debian/debhelper\\\\.log"
  "html"
  "Core.tag"
  "Testing"
  "build/"
  "wbuild/"
  "buildwin64/"
  "build-stamp"
  "install_manifest.txt"
  "DartConfiguration.tcl"
  ${CPACK_SOURCE_IGNORE_FILES}
  )



#dch -Dstretch "message"
#cmake ..
#make deb
# scp libpappsomspp* proteus.moulon.inra.fr:/var/www/apt/incoming
# reprepro -Vb /var/www/apt processincoming default
# apt-get remove libpappsomspp*
#
#  debuild -S -sa
# dput -f olivier-langella *changes


#dpkg-deb -x libpappsomspp-qt4_0.0.4-1_amd64.deb libpappsomspp-qt4_0.0.4-1
#dpkg-gensymbols -v0 -plibpappsomspp-qt4 -Plibpappsomspp-qt4_0.0.4-1 -Osymbols
#cp symbols ../debian/libpappsomspp-qt4.symbols


#dpkg-deb -x libpappsomspp-qt5_0.0.4-1_amd64.deb libpappsomspp-qt5_0.0.4-1
#dpkg-gensymbols -v0 -plibpappsomspp-qt5 -Plibpappsomspp-qt5_0.0.4-1 -Osymbols
#cp symbols ../debian/libpappsomspp-qt5.symbols


if(MACOS)
  set(CPACK_GENERATOR "Bundle")
endif()

set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_DEBSOURCE_PACKAGE_FILE_NAME "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.orig")
include(CPack)

if(UNIX)
  #This creates deb packages:



  add_custom_target(targz
    cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz libpappsomspp-${PAPPSOMSPP_VERSION}.tar.gz
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating .tar.gz" VERBATIM
    )


  add_custom_target(deb
    ln -s libpappsomspp-${PAPPSOMSPP_VERSION}.tar.gz libpappsomspp_${PAPPSOMSPP_VERSION}.orig.tar.gz && cd libpappsomspp-${PAPPSOMSPP_VERSION} && dpkg-buildpackage -sa
    DEPENDS targz
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating Debian package" VERBATIM
    )

  file(GLOB changesdebs "${CMAKE_BINARY_DIR}/pappsomspp_*.dsc")

  foreach(libfile ${changesdebs})
    set(changesdeb "${libfile}")
  endforeach(libfile)

  message ("changes debian file : ${changesdeb}")
  #lintian -IEi --pedantic tandem-mass_2013.06.15-1_amd64.changes
  add_custom_target(lintian
    lintian -IEi --pedantic ${changesdeb}
    DEPENDS deb
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "lintian check" VERBATIM
    )



  #dpkg-deb -x libpappsomspp-qt4_0.0.4-1_amd64.deb libpappsomspp-qt4_0.0.4-1
  #dpkg-gensymbols -v0 -plibpappsomspp-qt4 -Plibpappsomspp-qt4_0.0.4-1 -Osymbols

=== src/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 03/03/2015
# Rework: April 2020 (Coronavirus confinement)

message(\n${BoldRed}"Now configuring src/ for ${PROJECT_NAME}"${ColourReset}\n)


configure_file (${CMAKE_SOURCE_DIR}/src/pappsomspp/config.h.cmake ${CMAKE_SOURCE_DIR}/src/pappsomspp/config.h)


add_definitions(-DWITHOUT_MZ5)


########################################################
# Files
set(CPP_FILES
	pappsomspp/utils.cpp
	pappsomspp/mzrange.cpp
	pappsomspp/precision.cpp

	pappsomspp/processing/combiners/mzintegrationparams.cpp
	pappsomspp/processing/combiners/tracecombiner.cpp
	pappsomspp/processing/combiners/traceminuscombiner.cpp
	pappsomspp/processing/combiners/tracepluscombiner.cpp

	pappsomspp/processing/filters/filterchargedeconvolution.cpp
	pappsomspp/processing/filters/filtercomplementionenhancer.cpp
	pappsomspp/processing/filters/filterlocalmaximum.cpp
	pappsomspp/processing/filters/filtermorpho.cpp
	pappsomspp/processing/filters/filternameinterface.cpp
	pappsomspp/processing/filters/filterpass.cpp
	pappsomspp/processing/filters/filterpseudocentroid.cpp
	pappsomspp/processing/filters/filterremovec13.cpp
	pappsomspp/processing/filters/filterresample.cpp
	pappsomspp/processing/filters/filtersuite.cpp
	pappsomspp/processing/filters/filtersuitestring.cpp
	pappsomspp/processing/filters/filtertandemremovec13.cpp
	pappsomspp/processing/filters/filtertriangle.cpp
	pappsomspp/processing/filters/savgolfilter.cpp

	pappsomspp/processing/filters/pwiz/ms/peakpickerqtof.hpp
	pappsomspp/processing/filters/pwiz/ms/simplepicker.hpp
	pappsomspp/processing/filters/pwiz/resample/convert2dense.hpp

	pappsomspp/processing/tandemwrapper/tandemwrapperrun.cpp
	pappsomspp/processing/tandemwrapper/xtandeminputsaxhandler.cpp
	pappsomspp/processing/tandemwrapper/xtandemoutputsaxhandler.cpp
	pappsomspp/processing/tandemwrapper/xtandempresetsaxhandler.cpp

	pappsomspp/massspectrum/massspectrumid.cpp
	pappsomspp/massspectrum/massspectrum.cpp
	pappsomspp/massspectrum/qualifiedmassspectrum.cpp

	pappsomspp/processing/combiners/massdatacombinerinterface.cpp
	pappsomspp/processing/combiners/massspectrumcombiner.cpp
	pappsomspp/processing/combiners/massspectrumpluscombiner.cpp
	pappsomspp/processing/combiners/massspectrumminuscombiner.cpp

	pappsomspp/amino_acid/aabase.cpp
	pappsomspp/amino_acid/aa.cpp
	pappsomspp/amino_acid/aamodification.cpp

	pappsomspp/fasta/fastafileindexer.cpp
	pappsomspp/fasta/fastareader.cpp
	pappsomspp/fasta/fastaoutputstream.cpp

	pappsomspp/grouping/grpexperiment.cpp
	pappsomspp/grouping/grppeptide.cpp
	pappsomspp/grouping/grpprotein.cpp
	pappsomspp/grouping/grpgroup.cpp
	pappsomspp/grouping/grpsubgroup.cpp
	pappsomspp/grouping/grppeptideset.cpp
	pappsomspp/grouping/grpmappeptidetogroup.cpp
	pappsomspp/grouping/grpmappeptidetosubgroupset.cpp
	pappsomspp/grouping/grpsubgroupset.cpp
	pappsomspp/grouping/grpgroupingmonitor.cpp

	pappsomspp/msfile/msfileaccessor.cpp
	pappsomspp/msfile/msfilereader.cpp
	pappsomspp/msfile/pwizmsfilereader.cpp
	pappsomspp/msfile/timsmsfilereader.cpp
	pappsomspp/msfile/xymsfilereader.cpp

	pappsomspp/msrun/alignment/msrunretentiontime.cpp
	pappsomspp/msrun/alignment/template.cpp
	pappsomspp/msrun/output/mzxmloutput.cpp
	pappsomspp/msrun/output/mgfoutput.cpp
	pappsomspp/msrun/msrundatasettreenode.cpp
	pappsomspp/msrun/msrundatasettree.cpp
	pappsomspp/msrun/msrunid.cpp
	pappsomspp/msrun/msrunreader.cpp
	pappsomspp/msrun/private/pwizmsrunreader.cpp
	pappsomspp/msrun/private/timsmsrunreader.cpp
	pappsomspp/msrun/private/timsmsrunreaderms2.cpp
	pappsomspp/msrun/private/timsmsrunreaderms2selected.cpp
	pappsomspp/msrun/xymsrunreader.cpp

	pappsomspp/obo/obopsimod.cpp
	pappsomspp/obo/filterobopsimodsink.cpp
	pappsomspp/obo/filterobopsimodtermaccession.cpp
	pappsomspp/obo/filterobopsimodtermlabel.cpp
	pappsomspp/obo/filterobopsimodtermdiffmono.cpp
	pappsomspp/obo/filterobopsimodtermname.cpp

	pappsomspp/peptide/ion.cpp
	pappsomspp/peptide/peptideinterface.cpp
	pappsomspp/peptide/peptide.cpp
	pappsomspp/peptide/peptidefragment.cpp
	pappsomspp/peptide/peptidefragmention.cpp
	pappsomspp/peptide/peptidefragmentionlistbase.cpp
	pappsomspp/peptide/peptidenaturalisotope.cpp
	pappsomspp/peptide/peptidenaturalisotopelist.cpp
	pappsomspp/peptide/peptidenaturalisotopeaverage.cpp
	pappsomspp/peptide/peptiderawfragmentmasses.cpp
	pappsomspp/peptide/peptidestrparser.cpp

	pappsomspp/protein/protein.cpp
	pappsomspp/protein/enzyme.cpp
	pappsomspp/protein/peptidesizefilter.cpp
	pappsomspp/protein/peptidebuilder.cpp
	pappsomspp/protein/peptidevariablemodificationbuilder.cpp
	pappsomspp/protein/peptidevariablemodificationreplacement.cpp
	pappsomspp/protein/peptidefixedmodificationbuilder.cpp
	pappsomspp/protein/peptidemodificatorbase.cpp
	pappsomspp/protein/peptidemodificatortee.cpp
	pappsomspp/protein/peptidemethioninremove.cpp
	pappsomspp/protein/peptidemodificatorpipeline.cpp
	pappsomspp/protein/peptidesemienzyme.cpp

	pappsomspp/psm/experimental/ionisotoperatioscore.cpp
	pappsomspp/psm/morpheus/morpheusscore.cpp
	pappsomspp/psm/peakionmatch.cpp
	pappsomspp/psm/peakionisotopematch.cpp
	pappsomspp/psm/peptidespectrummatch.cpp
	pappsomspp/psm/peptideisotopespectrummatch.cpp
	pappsomspp/psm/xtandem/xtandemhyperscore.cpp
	pappsomspp/psm/xtandem/xtandemhyperscorebis.cpp
	pappsomspp/psm/xtandem/xtandemspectrumprocess.cpp

	pappsomspp/trace/datapoint.cpp
	pappsomspp/trace/linearregression.cpp
	pappsomspp/trace/maptrace.cpp
	pappsomspp/trace/trace.cpp

	pappsomspp/vendors/tims/mzcalibration/mzcalibrationinterface.cpp
	pappsomspp/vendors/tims/mzcalibration/mzcalibrationmodel1.cpp
	pappsomspp/vendors/tims/mzcalibration/mzcalibrationstore.cpp
	pappsomspp/vendors/tims/xicextractor/timsdirectxicextractor.cpp
	pappsomspp/vendors/tims/xicextractor/timsxicextractorinterface.cpp
	pappsomspp/vendors/tims/timsbindec.cpp
	pappsomspp/vendors/tims/timsdata.cpp
	pappsomspp/vendors/tims/timsframe.cpp
	pappsomspp/vendors/tims/timsframebase.cpp
	pappsomspp/vendors/tims/timsms2centroidfilter.cpp

	pappsomspp/xic/xic.cpp
	pappsomspp/xic/qualifiedxic.cpp
	pappsomspp/xic/xicpeptideinterface.cpp
	pappsomspp/xic/xicpeptidefragmention.cpp
	pappsomspp/xic/xicpeptidefragmentionnaturalisotope.cpp

	pappsomspp/processing/detection/tracedetectionzivy.cpp
	pappsomspp/processing/detection/tracedetectionmoulon.cpp
	pappsomspp/processing/detection/tracepeak.cpp

	pappsomspp/xicextractor/private/msrunslice.cpp
	pappsomspp/xicextractor/private/msrunxicextractor.cpp
	pappsomspp/xicextractor/private/msrunxicextractordisk.cpp
	pappsomspp/xicextractor/private/msrunxicextractordiskbuffer.cpp
	pappsomspp/xicextractor/msrunxicextractorfactory.cpp
	pappsomspp/xicextractor/msrunxicextractorinterface.cpp
	)


find_package(Qt5 COMPONENTS Core Gui Svg Xml PrintSupport Sql Concurrent REQUIRED)

message("Qt5Core_LIBRARIES ${Qt5Core_LIBRARIES}")
message("QT_CORE_LIB ${QT_CORE_LIB}")

set(pappsomspp_RCCS libpappsomsppresources.qrc)
# generate rules for building source files from the resources
qt5_add_resources(pappsomspp_RCC_SRCS ${pappsomspp_RCCS})

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)


#############################################################
# Build the static lib
add_library(pappsomspp-static STATIC ${CPP_FILES} ${pappsomspp_RCC_SRCS})

set_target_properties(pappsomspp-static
	PROPERTIES OUTPUT_NAME pappsomspp
	CLEAN_DIRECT_OUTPUT 1
	LINK_FLAGS -Wl,--whole-archive
	)

target_include_directories(pappsomspp-static PUBLIC
	${PwizLite_INCLUDE_DIRS}
	)

target_link_libraries(pappsomspp-static 
	Qt5::Core
	Qt5::Gui
	Qt5::Xml
	Qt5::Svg
	Qt5::PrintSupport
	Qt5::Sql
	Qt5::Concurrent
	Zstd::Zstd
	Alglib::Alglib
	SQLite::SQLite3
	Boost::iostreams
	Boost::filesystem
	Boost::thread
	Boost::chrono
	ZLIB::ZLIB
	PwizLite::PwizLite
	)


# FIXME: should check that this still required. It was years ago.
if(WIN32 OR _WIN32)

	target_link_libraries(pappsomspp-static 
		stdc++
		)
endif()


#############################################################
# Build the shared lib
add_library(pappsomspp-shared SHARED ${CPP_FILES} ${pappsomspp_RCC_SRCS})

set_target_properties(pappsomspp-shared
	PROPERTIES OUTPUT_NAME pappsomspp
	CLEAN_DIRECT_OUTPUT 1
	VERSION ${PAPPSOMSPP_VERSION}
	SOVERSION ${PAPPSOMSPP_VERSION_MAJOR}
    LINK_FLAGS "${LINKER_FLAGS}"
	)

target_include_directories(pappsomspp-shared PUBLIC
	${PwizLite_INCLUDE_DIRS}
	)

target_link_libraries(pappsomspp-shared 
	Qt5::Core
	Qt5::Gui
	Qt5::Xml
	Qt5::Svg
	Qt5::PrintSupport
	Qt5::Sql
	Qt5::Concurrent
	Zstd::Zstd
	SQLite::SQLite3
	Alglib::Alglib
	Boost::iostreams
	Boost::filesystem
	Boost::thread
	Boost::chrono
	ZLIB::ZLIB
	PwizLite::PwizLite
	)


# Should check that this still required. It was years ago.
if(WIN32 OR _WIN32)

	target_link_libraries(pappsomspp-shared 
		stdc++
		)

endif()


# Install libs

install(TARGETS pappsomspp-shared 
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	# This one is for WIN32
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	)

install(TARGETS pappsomspp-static 
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})


# Install headers
install(DIRECTORY pappsomspp/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/pappsomspp 
	FILES_MATCHING PATTERN "*.h"
	PATTERN "*.hpp")

add_subdirectory("pappsomspp/widget")

=== tests/CMakeLists.txt ===
if(MAKE_TESTS AND (WIN64 OR (UNIX AND NOT APPLE)))

  message(\n${BoldRed}"Now configuring src/tests for ${CMAKE_PROJECT_NAME}"${ColourReset}\n)

  # CMake script for PAPPSOms++ library
  # Authors: Copyright Olivier Langella & Filippo Rusconi
  # GPLv3+
  # Created: 03/03/2015 from the CMakeLists file of the Bio++ project
  # Changes 20201201 by FR.


  IF(USEPAPPSOTREE)
    set(USEPAPPSOTREE 1)
    message("USEPAPPSOTREE is defined")
    message("Please be sure that your environment has accessed to the PAPPSO directory")
  ENDIF(USEPAPPSOTREE)

  configure_file (config.h.cmake ${CMAKE_SOURCE_DIR}/tests/config.h)

  #apt-get install libpwiz-dev libboost-dev
  #CTEST_OUTPUT_ON_FAILURE=TRUE make test
  #make test ARGS="-V"
  #make test ARGS="-V -I 4,4"

  #export LD_LIBRARY_PATH=/home/langella/developpement/git/pappsomspp/build/src:$LD_LIBRARY_PATH

  #set(CMAKE_MODULE_PATH "/usr/share/cmake-3.0/Modules")

  find_package(Catch2 REQUIRED)


  if(OdsStream_FOUND)
  else (OdsStream_FOUND)
    find_package(OdsStream REQUIRED)
  endif(OdsStream_FOUND)

  if(TARGET OdsStream::Core)
    message("OdsStream::Core found.")
  else (TARGET OdsStream::Core)
    message("OdsStream::Core not found.")
  endif (TARGET OdsStream::Core)

  macro(TEST_FIND_LIBRARY OUTPUT_LIBS lib_name include_to_find)
    #start:
    find_path("${CMAKE_SOURCE_DIR}/src" ${include_to_find})

    set(${lib_name}_NAMES ${lib_name} ${lib_name}.lib ${lib_name}.dll)

    find_library(${lib_name}_LIBRARY NAMES ${${lib_name}_NAMES})

    if(${lib_name}_LIBRARY)

      message("-- Library ${lib_name} found here:")
      message("   includes: ${${lib_name}_INCLUDE_DIR}")
      message("   dynamic libraries: ${${lib_name}_LIBRARY}")
      message(WARNING "Library ${lib_name} is already installed in the system tree. Test will be built against it. This may lead to unexpected results. You may want to do 'make install' before 'make test', or remove the installed version.")

    else()

      set(PappsoMSpp_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/src")
      set(PappsoMSpp_LIBRARY "${CMAKE_BINARY_DIR}/src/libpappsomspp.so")
      set(PappsoMSppWidget_LIBRARY "${CMAKE_BINARY_DIR}/src/pappsomspp/widget/libpappsomspp-widget.so")

      message("${PappsoMSpp_INCLUDE_DIRS}")
      message("${PappsoMSpp_LIBRARY}")
      message("${PappsoMSppWidget_LIBRARY}")

    endif()

    set(${OUTPUT_LIBS} ${${OUTPUT_LIBS}} ${${lib_name}_LIBRARY})

  endmacro(TEST_FIND_LIBRARY)

  # File list
  set(CPP_TEST_FILES
    saxparsers/xtandemresultshandler.cpp
    )


  find_package(Qt5 COMPONENTS Core Xml Gui Concurrent REQUIRED)

  # These source files are compiled into a single Catch2-based test binary.
  set(catch2_only_cpp_SRCS
    catch-only-tests-main.cpp
    test_datapoint.cpp
    test_trace.cpp
    test_maptrace.cpp
    test_tracecombiner.cpp
    test_massspectrum.cpp
    test_mzintegrationparams.cpp
    test_massspectrumcombiner.cpp
    )

  add_executable(catch2-only-tests
    ${catch2_only_cpp_SRCS}
    )

  set_property(TARGET catch2-only-tests PROPERTY CXX_STANDARD 17) # we want C++17

  # So that the <xxx>-based #includes find the proper header files even
  # if these are not installed on the system.
  include_directories("${CMAKE_SOURCE_DIR}/src")

  target_include_directories(catch2-only-tests PRIVATE
    ${INCLUDE_DIRECTORIES}
    )

  set(required_target_link_libraries
    pappsomspp-shared
    Catch2::Catch2
    )

  target_link_libraries(catch2-only-tests
    ${required_target_link_libraries})

  # Add the Catch2-based single binary test file to the CMake's test suite so
  # that it gets called using 'make test'. To see the output, add "ARGS=-V" to
  # the call.
  add_test(catch2-only-tests "catch2-only-tests")


  add_executable(test_fasta_reader test_fasta_reader.cpp)
  target_link_libraries(test_fasta_reader Qt5::Core pappsomspp-shared)
  add_test(test_fasta_reader "test_fasta_reader")


  add_executable(test_protein test_protein.cpp)
  target_link_libraries(test_protein Qt5::Core pappsomspp-shared)
  add_test(test_protein "test_protein")

  add_executable(test_xic test_xic.cpp)
  target_link_libraries(test_xic Qt5::Core pappsomspp-shared Qt5::Gui OdsStream::Core)
  add_test(test_xic "test_xic")


  add_executable(test_massrange test_massrange.cpp)
  target_link_libraries(test_massrange Qt5::Core pappsomspp-shared)
  add_test(test_massrange "test_massrange")

  add_executable(test_aa test_aa.cpp)
  target_link_libraries(test_aa Qt5::Core pappsomspp-shared Catch2::Catch2)
  add_test(test_aa "test_aa")

  add_executable(test_peptide test_peptide.cpp)
  target_link_libraries(test_peptide Qt5::Core Qt5::Gui pappsomspp-shared)
  add_test(test_peptide "test_peptide")

  add_executable(test_peptidenaturalisotopelist test_peptidenaturalisotopelist.cpp)
  target_link_libraries(test_peptidenaturalisotopelist Qt5::Core Qt5::Gui pappsomspp-shared)
  add_test(test_peptidenaturalisotopelist "test_peptidenaturalisotopelist")


  add_executable(test_natural_isotope_average test_natural_isotope_average.cpp)
  target_link_libraries(test_natural_isotope_average Qt5::Core pappsomspp-shared)
  add_test(test_natural_isotope_average "test_natural_isotope_average")


  add_executable(test_peptidefragment test_peptidefragment.cpp)
  target_link_libraries(test_peptidefragment Qt5::Core Qt5::Gui pappsomspp-shared)
  add_test(test_peptidefragment "test_peptidefragment")

  add_executable(test_fragmentationcid test_fragmentationcid.cpp)
  target_link_libraries(test_fragmentationcid Qt5::Core Qt5::Gui pappsomspp-shared)
  add_test(test_fragmentationcid "test_fragmentationcid")

  #IF (FALSE) 
  add_executable(test_big_hyperscore test_big_hyperscore.cpp ${CPP_TEST_FILES})
  target_link_libraries(test_big_hyperscore Qt5::Core Qt5::Gui Qt5::Xml pappsomspp-shared)
  add_test(test_big_hyperscore "test_big_hyperscore")
  #ENDIF(FALSE)


  add_executable(test_rawmasslist test_rawmasslist.cpp)
  target_link_libraries(test_rawmasslist Qt5::Core Qt5::Gui pappsomspp-shared)
  add_test(test_rawmasslist "test_rawmasslist")


  add_executable(test_isotope_with_spectrum test_isotope_with_spectrum.cpp)
  target_link_libraries(test_isotope_with_spectrum Qt5::Core Qt5::Gui pappsomspp-shared  ${Boost_LIBRARIES})
  add_test(test_isotope_with_spectrum "test_isotope_with_spectrum")
  set(TEST_LIST ${TEST_LIST} test_isotope_with_spectrum)

  add_executable(test_hyperscore test_hyperscore.cpp)
  target_link_libraries(test_hyperscore Qt5::Core pappsomspp-shared Qt5::Gui  ${Boost_LIBRARIES})
  add_test(test_hyperscore "test_hyperscore")
  set(TEST_LIST ${TEST_LIST} test_hyperscore)

  add_executable(test_xtandem_spectrum test_xtandem_spectrum.cpp)
  target_link_libraries(test_xtandem_spectrum Qt5::Core pappsomspp-shared Qt5::Gui  ${Boost_LIBRARIES})
  add_test(test_xtandem_spectrum "test_xtandem_spectrum")
  set(TEST_LIST ${TEST_LIST} test_xtandem_spectrum)

  add_executable(test_scan_15968 test_scan_15968.cpp)
  target_link_libraries(test_scan_15968 Qt5::Core Qt5::Gui pappsomspp-shared  ${Boost_LIBRARIES})
  add_test(test_scan_15968 "test_scan_15968")
  set(TEST_LIST ${TEST_LIST} test_scan_15968)

  add_executable(test_psm test_psm.cpp)
  target_link_libraries(test_psm Qt5::Core pappsomspp-shared Qt5::Gui Qt5::Concurrent  ${Boost_LIBRARIES})
  add_test(test_psm "test_psm")
  set(TEST_LIST ${TEST_LIST} test_psm)

  add_executable(test_xicextractor test_xicextractor.cpp)
  target_link_libraries(test_xicextractor Qt5::Core Qt5::Gui pappsomspp-shared  ${Boost_LIBRARIES} OdsStream::Core)
  add_test(test_xicextractor "test_xicextractor")
  set(TEST_LIST ${TEST_LIST} test_xicextractor)

  add_executable(test_trace_filters test_trace_filters.cpp)
  target_link_libraries(test_trace_filters Qt5::Core Qt5::Gui Qt5::Concurrent pappsomspp-shared  ${Boost_LIBRARIES})
  add_test(test_trace_filters "test_trace_filters")
  set(TEST_LIST ${TEST_LIST} test_trace_filters)


  add_executable(test_msrunalignment test_msrunalignment.cpp)
  target_include_directories (test_msrunalignment PUBLIC ${QUAZIP_INCLUDE_DIR})
  target_link_libraries(test_msrunalignment Qt5::Core Qt5::Gui Qt5::Concurrent pappsomspp-shared  ${Boost_LIBRARIES} OdsStream::Core)
  add_test(test_msrunalignment "test_msrunalignment")
  set(TEST_LIST ${TEST_LIST} test_msrunalignment)

  add_executable(test_msrunoutput test_msrunoutput.cpp)
  target_link_libraries(test_msrunoutput Qt5::Core Qt5::Gui Qt5::Concurrent pappsomspp-shared  ${Boost_LIBRARIES} OdsStream::Core Catch2::Catch2)
  add_test(test_msrunoutput "test_msrunoutput")
  set(TEST_LIST ${TEST_LIST} test_msrunoutput)

  add_executable(test_timsframe test_timsframe.cpp)
  target_link_libraries(test_timsframe Qt5::Core pappsomspp-shared Catch2::Catch2)
  add_test(test_timsframe "test_timsframe")


  if(UNIX)

    set_property(TEST  test_big_hyperscore test_xic test_protein test_fasta_reader 
      test_massrange test_aa test_peptide test_peptidenaturalisotopelist test_peptidefragment 
      test_fragmentationcid ${TEST_LIST} test_natural_isotope_average test_rawmasslist 
      test_timsframe 
      PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")

  endif()

  if(WIN32)
    set(ENV{PATH} "$ENV{PATH};..\\src")
  endif()

else()
  message(STATUS "Tests are not built.")
endif()

=== src/pappsomspp/widget/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 22/12/2017
# Rework: April 2020 (Coronavirus confinement)

message(\n${BoldRed}"Now configuring src/widget for ${PROJECT_NAME}"${ColourReset}\n)


find_package(Qt5 COMPONENTS Core Gui PrintSupport Svg REQUIRED)


if(NOT QCustomPlot_FOUND)
	message("Still searching for QCustomPlot")
	find_package(QCustomPlot REQUIRED)
	add_definitions(-DQCUSTOMPLOT_USE_LIBRARY)
endif()


########################################################
# Files
SET(PAPPSOWIDGET_CPP_FILES
	graphicdevicewidget.cpp
	precisionwidget/precisionwidget.cpp
	massspectrumwidget/qcpspectrum.cpp
	massspectrumwidget/massspectrumwidget.cpp
	xicwidget/qcpxic.cpp
	xicwidget/xicwidget.cpp
	plotwidget/colormapplotconfig.cpp
	plotwidget/baseplotwidget.cpp
	plotwidget/basetraceplotwidget.cpp
	plotwidget/ticxicchromtraceplotwidget.cpp
	plotwidget/massspectraceplotwidget.cpp
	plotwidget/driftspectraceplotwidget.cpp
	plotwidget/basecolormapplotwidget.cpp
	plotwidget/ticxicchrommassspeccolormapplotwidget.cpp
	plotwidget/ticxicchromdriftspeccolormapplotwidget.cpp
	plotwidget/driftspecmassspeccolormapplotwidget.cpp
	)


#############################################################
# Build the static lib
add_library(pappsomspp-widget-static STATIC ${PAPPSOWIDGET_CPP_FILES})

set_target_properties(pappsomspp-widget-static
	PROPERTIES OUTPUT_NAME pappsomspp-widget
	CLEAN_DIRECT_OUTPUT 1
	)

target_link_libraries(pappsomspp-widget-static
	QCustomPlot::QCustomPlot
	Qt5::Core
	Qt5::Widgets
	Qt5::Svg
	Qt5::PrintSupport
	Boost::iostreams
	Boost::filesystem
	Boost::thread
	Boost::chrono
	PwizLite::PwizLite
	)


# FIXME: should check that this still required. It was years ago.
if(WIN32 OR _WIN32)

	target_link_libraries(pappsomspp-widget-static 
		stdc++
		)
endif()


#############################################################
# Build the shared lib
add_library(pappsomspp-widget-shared SHARED ${PAPPSOWIDGET_CPP_FILES})

set_target_properties(pappsomspp-widget-shared
	PROPERTIES OUTPUT_NAME pappsomspp-widget
	CLEAN_DIRECT_OUTPUT 1
	VERSION ${PAPPSOMSPP_VERSION}
	SOVERSION ${PAPPSOMSPP_VERSION_MAJOR}
	#COMPILE_DEFINITIONS " ${QT_DEFINITIONS}"
	#INCLUDE_DIRECTORIES "${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR}"
	)

target_link_libraries(pappsomspp-widget-shared
	QCustomPlot::QCustomPlot
	Qt5::Core
	Qt5::Widgets
	Qt5::Svg
	Qt5::PrintSupport
	pappsomspp-shared
	Boost::iostreams
	Boost::filesystem
	Boost::thread
	Boost::chrono
	PwizLite::PwizLite
	)


# Should check that this still required. It was years ago.
if(WIN32 OR _WIN32)

	target_link_libraries(pappsomspp-widget-shared 
		stdc++
		)

endif()


# Install libs

install(TARGETS pappsomspp-widget-shared 
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	# This one is for WIN32
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	)

install(TARGETS pappsomspp-widget-static 
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})


# Install headers
install(DIRECTORY pappsomspp/widget 
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/pappsomspp/widget
	FILES_MATCHING PATTERN "*.h"
	PATTERN "*.hpp")

=== debian/changelog ===
libpappsomspp (0.8.15-1) unstable; urgency=low

  * New upstream version depending on libodsstream 0.7.11.

  * Disable make test for the moment.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 21 Dec 2020 18:05:07 +0100

libpappsomspp (0.8.14-1~buster+1) buster; urgency=medium

  * catch2 test suite is working
  * fix for standard exception compatibility

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 16 Dec 2020 14:00:13 +0100

libpappsomspp (0.8.13-1~buster+1) buster; urgency=medium

  * buster package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 09 Dec 2020 15:36:32 +0100

libpappsomspp (0.8.13-1) unstable; urgency=low

  * New upstream with improvement in the XIC widgets.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 08 Dec 2020 16:29:03 +0100

libpappsomspp (0.8.12-1) UNRELEASED; urgency=low

  * New upstream version with new tests imported from mineXpert2
    (Catch2-based).

  * See below for changes between 0.8.8 and now.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 02 Dec 2020 14:28:10 +0100

libpappsomspp (0.8.11-1~buster+1) buster; urgency=medium

  * test added
  * bug fix in chargeDeconvolution filter
  * including catch2 framework

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 24 Nov 2020 10:08:59 +0100

libpappsomspp (0.8.10-1~buster+1) buster; urgency=medium

  * better tandemrun wrapper
  * better FilterSuiteString

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 18 Nov 2020 10:13:20 +0100

libpappsomspp (0.8.9-1~buster+1) buster; urgency=medium

  * rewritten TimsTOF mz calibration API
  * new FilterNameInterface to build Filter with strings
  * Thomas Renne added in the copyright debian notice

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 17 Nov 2020 13:31:57 +0100

libpappsomspp (0.8.8-1~buster+1) buster; urgency=medium

  * autoremove directory created for tandem run wrapper

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 02 Nov 2020 10:50:32 +0100

libpappsomspp (0.8.8-1) unstable; urgency=low

  * Add the possibility to recalculate the x,y,z axis scale to log10 or
    linear.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 21 Oct 2020 14:29:32 +0200

libpappsomspp (0.8.7-1~buster+1) buster; urgency=medium

  * make new builtin centroid interface available throught
    TimsMsRunReader
  * access to the underlying timdata pointer from TimsMsRunReader

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 15 Oct 2020 09:14:24 +0200

libpappsomspp (0.8.6-1~buster+1) buster; urgency=medium

  * builtin centroid for timsdata

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 14 Oct 2020 10:22:37 +0200

libpappsomspp (0.8.5-1~buster+1) buster; urgency=medium

  * more checks on file permissions for tandem run wrapper
  * charge deconvolution documented

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 09 Oct 2020 15:37:09 +0200

libpappsomspp (0.8.4-1~buster+1) buster; urgency=medium

  * new charge deconvolution filter

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 08 Oct 2020 10:52:40 +0200

libpappsomspp (0.8.3-1~buster+1) buster; urgency=medium

  * better msrunreader error messages
  * regorganised xic extractor to ensure that device is released

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 05 Oct 2020 10:19:53 +0200

libpappsomspp (0.8.2-1) buster; urgency=low

  [ Filippo Rusconi ]
  * Fixes in the minus combiners.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 23 Sep 2020 15:22:50 +0200

libpappsomspp (0.8.2-1~buster+1) buster; urgency=medium

  * msrunreader new api to release/acquire file pointers

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 25 Sep 2020 15:07:16 +0200

libpappsomspp (0.8.1-1) unstable; urgency=low

  * Fix bug due to not testing pointer against nullptr.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 21 Sep 2020 17:20:31 +0200

libpappsomspp (0.8.0-1) UNRELEASED; urgency=low

  * Add MSn support.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 21 Sep 2020 15:53:13 +0200

libpappsomspp (0.7.15-1) unstable; urgency=low

  * Attempt at fixing the test/test_massrange.cpp failure in i386 platforms.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 10 Sep 2020 18:07:48 +0200

libpappsomspp (0.7.14-1) unstable; urgency=low

  * Bug fix in DataPoint initialization using initialize().

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 02 Sep 2020 10:23:48 +0200

libpappsomspp (0.7.14-1~buster+1) buster; urgency=medium

  * new filters : FilterComplementIonEnhancer, FilterGreatestYperWindow,
    FilterRemoveC13

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 27 Aug 2020 10:36:53 +0200

=== debian/control ===
Source: libpappsomspp
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 12),
 dh-exec (>= 0.3),
 dpkg-dev (>= 1.18.25),
 cmake (>=3.12),
 d-shlibs (>= 0.48~),
 qtbase5-dev,
 libqt5svg5-dev (>= 5.7.0),
 qhelpgenerator-qt5 (>= 5.15.2),
 libpwizlite-dev (>= 3.0.2),
 libqcustomplot-dev (>= 2.0.1),
 libodsstream-dev (>= 0.7.11),
 libalglib-dev,
 libsqlite3-dev,
 libzstd-dev (>= 1.3.3),
 libboost-dev,
 libboost-iostreams-dev,
 libboost-thread-dev,
 libboost-system-dev,
 libboost-filesystem-dev,
 libboost-chrono-dev,
 doxygen,
 catch2
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/debichem-team/libpappsomspp
Vcs-Git: https://salsa.debian.org/debichem-team/libpappsomspp.git
Homepage: http://pappso.inrae.fr/bioinfo


Package: libpappsomspp0
Architecture: any
Multi-Arch: same
Replaces: libpappsomspp0 (<= ${binary:Version})
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: C++ library to handle mass spectrometry data (non-GUI runtime)
 libpappsomspp provides a simple API to perform a variety of 
 tasks related to mass spectrometry. Although the library is 
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package ships the non-GUI library.


Package: libpappsomspp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Replaces: libpappsomspp-dev (<< ${binary:Version})
Depends: libpappsomspp0 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: libpappsomspp-doc
Description: C++ library to handle mass spectrometry data (development files)
 libpappsomspp provides a simple API to perform a variety of 
 tasks related to mass spectrometry. Although the library is 
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package ships the development files for the non-GUI library.


Package: libpappsomspp-widget0
Architecture: any
Multi-Arch: same
Replaces: libpappsomspp-widget0 (<< ${binary:Version})
Depends: libpappsomspp0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: C++ library to handle mass spectrometry data (GUI runtime)
 libpappsomspp provides a simple API to perform a variety of 
 tasks related to mass spectrometry. Although the library is 
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package ships the GUI library.


Package: libpappsomspp-widget-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Replaces: libpappsomspp-widget-dev (<< ${binary:Version})
Depends: libpappsomspp-widget0 (= ${binary:Version}),
         libpappsomspp-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: libpappsomspp-doc
Description: C++ library to handle mass spectrometry data (GUI development files)
 libpappsomspp provides a simple API to perform a variety of 
 tasks related to mass spectrometry. Although the library is 
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package ships the development files for the GUI library.


Package: libpappsomspp-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: C++ library to handle mass spectrometry data (developer documentation)
 libpappsomspp provides a simple API to perform a variety of 
 tasks related to mass spectrometry. Although the library is 
 proteomics oriented, it also features interesting functions to perform
 mass spectral data integrations. The main features are:
 .
 - abstractions for peptides, ions, amino acid modifications...
 - integrations to mass spectra, drift spectra, XIC chromatograms...
 .
 This package contains the developer documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=cmake

# For automating the d/*.links stuff.
export LIBPAPPSOMSPP_VERSION=$(DEB_VERSION_UPSTREAM)
export LIBPAPPSOMSPP_SOVERSION=0

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=Release \
		-DMAKE_TESTS=0 \
		-DCMAKE_SKIP_RPATH=1 \
		-DUSEPAPPSOTREE=0
		
override_dh_auto_build:
	dh_auto_build --no-parallel
	dh_auto_build -- doc
# Required because it would not run automatically
#	make test
